////////////////////////////////////////////////////////////////////////////////
//                       zIP 2.0 - Aston Plug-in
//                       by Zealot-6 (Travis Collins)
//                           zealotsix@gmail.com
//
////////////////////////////////////////////////////////////////////////////////
// Changelog
////////////////////////////////////////////////////////////////////////////////
//
// 2.0:    2/18/07
//      Public Release
//
// 2.0 b1: 2/14/07
//      Converted to the new plugin SDK, added skin support
//
// 1.1:    8/16/05
//      Fixed bug that moves plugin to 0,0 when games are played
//      Added context menu to refresh and to edit settings
//
// 1.0:    8/15/05
//      a few code tweeks, and the public release
//
// 1.0 b1: 2/21/05
//
///////////////////////////////////////////////////////////////////////////////


library zIP;

{$IFDEF Debug}
{$E .plg}
{$ELSE}
{$I ..\plg.pas}
{$ENDIF}
{$IMAGEBASE $00400000}
uses
  Windows,
  Messages,
  urlmon,
  SysUtils,
  shellapi,
  ActiveX,
  IdHTTP,
  clipbrd,
  FNxxx in '..\SDK\FNxxx.pas',
  AstonSDK in '..\SDK\AstonSDK.pas',
  st_api in '..\SDK\st_api.pas',
  Drawpng in '..\SDK\Drawpng.pas',
  AstonEx in '..\SDK\AstonEx.pas';



procedure ReadConfig;forward;
procedure TimerCallBack(hWnd: HWND; Message: Word; TimerID: Word; SysTime: LongInt);stdcall;forward;
function BuildURL():string;forward;
procedure CancelDownload();forward;
procedure UpdateDisplay();forward;
procedure CreateGetThread();forward;
procedure LogMessage(sMessage: string);forward;

type
  cDownloadStatusCallback = class(TObject,IUnknown,IBindStatusCallback)
  private
    function QueryInterface(const IID: TGUID; out Obj): HResult; stdcall;
    function _AddRef: Integer; stdcall;
    function _Release: Integer; stdcall;
    function OnStartBinding(dwReserved: DWORD; pib: IBinding): HResult; stdcall;
    function GetPriority(out nPriority): HResult; stdcall;
    function OnLowResource(reserved: DWORD): HResult; stdcall;
    function OnProgress(ulProgress, ulProgressMax, ulStatusCode: ULONG; szStatusText: LPCWSTR): HResult; stdcall;
    function OnStopBinding(hresult: HResult; szError: LPCWSTR): HResult; stdcall;
    function GetBindInfo(out grfBINDF: DWORD; var bindinfo: TBindInfo): HResult; stdcall;
    function OnDataAvailable(grfBSCF: DWORD; dwSize: DWORD; formatetc: PFormatEtc; stgmed: PStgMedium): HResult; stdcall;
    function OnObjectAvailable(const iid: TGUID; punk: IUnknown): HResult; stdcall;
  end;

const
  szClassName = 'zIP';
  szHelp:PChar = 'zIP 2.0'#13#10+
  'Displays IP address on desktop';


  CM_CLOSET = WM_USER+1;
  szLookupMethod = 'Lookup Method';
  cLookupMethods = 2;
  vLookupMethods:array[0..cLookupMethods] of PChar=('www.whatismyip.org', 'www.whatismyip.com', 'www.ipchicken.com');


  szRefreshTime = 'Refresh Time (in minutes)';
  szDefaultText = 'DefaultText';
  szCoord = 'XY Coordinates';
  szLock = 'Lock XY';
  szZOrder = 'Z-Order';
  cZOrder = 2;
  vZOrder:array[0..cZOrder] of PChar=('Desktop', 'Normal', 'Always on top');

  szSkin = 'Skin';
  szTextColor = 'Text Color';
  szTextArea = 'Text Area';
  szFont = 'Font';
  szShadow = 'Use Text Shadow';
  szShadowColor = 'Shadow Color';

  //KeyCount - how many keys total
  KeyCount = 15;

  //Keys - the actual array of keys used in the plugin info
   Keys: array[1..KeyCount] of TKey = (
    (szKey:nil; nType:KEY_TAB; szHint:'General';    vDefault: 0; res1:0; res2:0),
    (szKey:szLookupMethod; nType:KEY_LIST or KEY_NOTHEME;  szHint: szLookupMethod; vDefault: 0; res1:cLookupMethods; res2:0),
    (szKey:szRefreshTime; nType:KEY_INT or KEY_NOTHEME;  szHint: szRefreshTime; vDefault: 30; res1:0; res2:0),
    (szKey:szDefaultText; nType:KEY_STRING or KEY_NOTHEME;  szHint: szDefaultText; vDefault: 0; res1:0; res2:0),
    (szKey:szZOrder; nType:KEY_LIST;  szHint: szZOrder; vDefault: 0; res1:cZOrder; res2:0),

    (szKey:nil; nType:KEY_TAB; szHint:'Skin';    vDefault: 0; res1:0; res2:0),
    (szKey:szSkin; nType:KEY_PICTURE;  szHint: szSkin; vDefault: 0; res1:0; res2:0),
    (szKey:szCoord; nType:KEY_POINT;  szHint: szCoord; vDefault: 0; res1:0; res2:0),
    (szKey:szLock; nType:KEY_BOOL;  szHint: szLock; vDefault: 0; res1:0; res2:0),


    (szKey:nil; nType:KEY_TAB; szHint:'Fonts and Colors';    vDefault: 0; res1:0; res2:0),
    (szKey:szFont; nType:KEY_FONT;  szHint: szFont; vDefault: 0; res1:0; res2:0),
    (szKey:szTextColor; nType:KEY_COLOR;  szHint: szTextColor; vDefault: $000000; res1:0; res2:0),
    (szKey:szShadow; nType:KEY_BOOL;  szHint: szShadow; vDefault: 0; res1:0; res2:0),
    (szKey:szShadowColor; nType:KEY_COLOR;  szHint: szShadowColor; vDefault: $FFFFFF; res1:0; res2:0),
    (szKey:szTextArea; nType:KEY_RECT;  szHint: szTextArea; vDefault: 0; res1:0; res2:0)
  );



var
  PluginInfo:TPluginInfo;
  AData: TAstonData;
  ii:AstonWND;
  iTextLayer: integer;
  i: integer;


  settingCoord:TPoint;

  settingLookupMethod: integer;
  settingZOrder: integer;
  settingRefreshTime: integer;
  settingDefaultText: string;

  settingSkin: array[0..MAX_PATH] of char;
  settingFont: TFont;
  settingTextColor: Cardinal;
  settingShadowColor: Cardinal;
  settingShadow: boolean;
  settingLock: boolean;
  settingTextArea: TRect;
  settingDebugMode: boolean;

  idTimer: Integer;

  tDisplayText: string = ' ';
  sDecIP: string;


  hThread: THandle = 0;
  HiEvent: THandle = 0;
  usercancel:bool;
//---------------------------------------------------------------------
procedure ShowError(text:Pchar);
begin
  SendMessage(AData.MainWindow, CM_ENTERMODAL, 0,0);   // disable recycle
  MessageBox(0, text, 'zIP Error', MB_ICONWARNING or MB_TOPMOST);
  SendMessage(AData.MainWindow, CM_LEAVEMODAL, 0,0);   // enable recycle
end;

//---------------------------------------------------------------------
//---------------------------------------------------------------------




//////////////////////////////////////////////////////////////////
//   function WindowProc                                        //
//                                                              //
//   Respond to windows messages                                //
//////////////////////////////////////////////////////////////////
function WindowProc(Window: HWnd; Message:UINT; WParam: WParam; LParam: LParam): Longint;  stdcall;
const
  SC_MenuItem1 = WM_USER + 1;
  SC_MenuItem2 = SC_MenuItem1 + 1;
  SC_MenuItem3 = SC_MenuItem2 + 1;
  SC_MenuItem4 = SC_MenuItem3 + 1;
  SC_MenuItem5 = SC_MenuItem4 + 1;
  SC_MenuItem6 = SC_MenuItem5 + 1;
  SC_MenuItem7 = SC_MenuItem6 + 1;
  SC_MenuItem8 = SC_MenuItem7 + 1;
  SC_MenuItem9 = SC_MenuItem8 + 1;
  SC_MenuItem10 = SC_MenuItem9 + 1;
  SC_MenuItem11 = SC_MenuItem10 + 1;
  SC_MenuItem12 = SC_MenuItem11 + 1;

var
  r:TRect;
  CFG:TCFG;
  PopMenu : HMenu;
  p: TPoint;
  szSetup: array[0..MAX_PATH+1] of char;
begin
 result := 0; // default result =  0 !!!!
  case Message of
    //////////////////////////////////
    // WM_RBUTTONUP                 //
    //                              //
    // Right Mouse Click            //
    // Popup Menu                   //
    //////////////////////////////////
    WM_RBUTTONUP,
    WM_NCRBUTTONUP:
    begin
      LogMessage('Right Mouse Click begin');
      PopMenu := CreatePopupMenu;

      // Create Popup Menu
      AppendMenu(PopMenu, MF_STRING, SC_MenuItem1, 'Refresh');
      AppendMenu(PopMenu, MF_STRING, SC_MenuItem2, 'Configure zIP');
      AppendMenu(PopMenu, MF_STRING, SC_MenuItem3, 'View Web Page');

      // Show Popup Menu
      GetCursorPos(p);
      TrackPopupMenu(PopMenu, TPM_LEFTALIGN, p.X, p.y, 0, Window, nil);
      DestroyMenu(PopMenu);
      LogMessage('Right Mouse Click end');
      result := 1;
      exit;
    end;

    //////////////////////////////////
    // WM_COMMAND                   //
    //                              //
    // Menu Item was chosen         //
    //////////////////////////////////
    WM_COMMAND:
    begin
      LogMessage('Menu Choice begin');
      case LOWORD(wParam) of
        SC_MenuItem1:   // Refresh
        begin
          CreateGetThread();
        end;
        SC_MenuItem2:   // Configure Plug-in
        begin
          szSetup[0] := '/';
          lstrcpy(@szSetup[1], Adata.Node.Path);
          SendMessage(Adata.MainWindow, CM_SETUPASTON, 0, integer(@szSetup[0]));
        end;
        SC_MenuItem3:   // View Web Page
        begin
          ShellExecute( 0,'open', PChar(BuildURL), NIL,NIL, SW_SHOW);
        end;
      end;
      LogMessage('Menu Choice end');
      result := 1;
      exit;
    end;


    //////////////////////////////////
    // WM_LBUTTONDBLCLK             //
    //                              //
    // Double click                 //
    // Copy IP Address to clipboard //
    //////////////////////////////////
    WM_LBUTTONDBLCLK,  // Copies text
    WM_NCLBUTTONDBLCLK:  //
    begin
      LogMessage('Double Click begin');
      Clipboard.AsText := tDisplayText;
      Beep();
      LogMessage('Double Click end');
    end;


    //////////////////////////////////
    // WM_EXITSIZEMOVE              //
    //                              //
    // End of window dragging       //
    // Save window position         //
    //////////////////////////////////
    WM_EXITSIZEMOVE:
    begin
      LogMessage('WM_EXITSIZEMOVE begin');
      GetWindowRect(window, r);
      RtlZeroMemory(@CFG, sizeof(TCFG));
      OpenCFGw(AData.PluginsCFG, @CFG);
      FindSection(szClassName, 1, @CFG);
      settingCoord.X := r.Left;
      settingCoord.Y := r.Top;
      SetCFGPoint(szCoord, settingCoord, @CFG);
      CloseCFGw(AData.PluginsCFG, false, @CFG);
      LogMessage('WM_EXITSIZEMOVE end');
      result := 1;
    end;


    //////////////////////////////////
    // CM_CLOSET                    //
    //                              //
    // Close thread                 //
    //////////////////////////////////
    CM_CLOSET:
    begin
      LogMessage('CM_CLOSET begin');

      CloseHandle(hThread);
      hThread := 0;
      LogMessage('CM_CLOSET end');
    end;

    end;
  result := DefWindowProc(Window, Message, WParam, LParam);
end;



//////////////////////////////////////////////////////////////////
//   procedure UpdateDisplay                                    //
//                                                              //
//   Draws text to the window                                   //
//////////////////////////////////////////////////////////////////
procedure UpdateDisplay();
var
  pp:Ppaint;
begin
  LogMessage('UpdateDisplay begin');

  pp := ii.LayerPaint_Begin(iTextLayer);
  ii.DrawText(pp.dc, PChar(tDisplayText), @settingTextArea, settingFont.Handle, DT_CENTER or DT_VCENTER, settingTextColor, settingShadow, settingShadowColor);
  ii.LayerPaint_End(pp);

  ii.RedRaw();
  LogMessage('UpdateDisplay end');
end;


//////////////////////////////////////////////////////////////////
//   procedure InitGlobalModule                                 //
//                                                              //
//   Everything starts here                                     //
//////////////////////////////////////////////////////////////////
procedure InitGlobalModule(const AstonData:PAstonData);stdcall;
var
  pic:Tpicture;
  iFlag: integer;
  r: TRect;
begin
  RtlMoveMemory(@AData, AstonData, SizeOf(TAstonData));
  ReadConfig();
  LogMessage('Read Config successful');

  iFlag := AWS_FADESTYLE or AWS_LAYERED;
  if (settingZOrder=0) then iFlag := iFlag or AWS_DRAWWALLPAPER;

  LogMessage('Set iFlag successful');

  ii:= AstonWND(CreateAstonWND(
          settingCoord.X,
          settingCoord.Y,
          AData.Desktop,
          settingZOrder,
          iFlag,
          @WindowProc,
          AData.Desktop,
          0));

  LogMessage('CreateAstonWnd successful');
  LogMessage('Aston Version: ' + IntToStr(ii.GetVer));
  LogMessage('OS: ' + AData.osver.szCSDVersion);
  if (ii = nil) then
  begin
   ShowError('zIP window wasn''t created');
   exit;
  end;
  if (ii.GetVer <19200) then   // check version
  begin
    ShowError('old version of AstonEx.dll! Please update Aston');
    exit;
  end;

  i := ii.SetBG(settingSkin); // add  background
  if (i<0) then
  begin
    // if there was no background image, create a transparant layer
    // to act as the base layer
    LogMessage('No skin, creating base layer');
    i := ii.CreateCustomLayer(0, 0, 0, settingTextArea.Right, settingTextArea.Bottom, LAYER_LAYERED,0);
  end;
  LogMessage('BG Layer creation successful');

  iFlag := LAYER_LAYERED;
  if (not settingLock) then
    iFlag := iFlag or LAYER_DRAG;
  LogMessage('Set iFlags successful');

  GetWindowRect(ii.wnd, r);
  LogMessage('GetWindowRect successful');

  // layer for drawing text
  iTextLayer := ii.CreateCustomLayer(1, 0, 0, r.Right - r.Left, r.Bottom - r.Top, iFlag,0);
  LogMessage('Create Text Layer successful');

  // Write the default text to the window
  UpdateDisplay();
  LogMessage('UpdateDisplay successful');


  ii.Show(1);
  LogMessage('ii.Show successful');

  CreateGetThread();
  LogMessage('Create Get Thread successful');

  idTimer := SetTimer(ii.wnd, 0, settingRefreshTime * 60000, @TimerCallBack);
  LogMessage('SetTimer successful');
  FreePicture(@pic);
  LogMessage('FreePicture successful');
  LogMessage('InitGlobalModule End');
end;
//---------------------------------------------------------------------

procedure DoneModule;stdcall;
begin
  KillTimer(ii.wnd, idTimer);
  CancelDownload();
  if HiEvent <> 0 then CloseHandle(HiEvent);
  HiEvent:=0;
  FreeFont(@settingFont);

   DestroyWindow(ii.wnd); // free all layers
   Pointer(ii) := nil; // You must set ii = nil otherwise AV !!
end;
//---------------------------------------------------------------------

function GetPluginInfo():PPluginInfo;stdcall;
begin
  PluginInfo.cbSize:= SizeOf(TPluginInfo);
  PluginInfo.szName:= szClassName;
  PluginInfo.szDescription:= szhelp;
  PluginInfo.szSection:= szClassName;
  PluginInfo.nKeyCount:= KeyCount;
  PluginInfo.Keys:= @Keys;
  Keys[2].res2:=integer(@vLookupMethods);
  Keys[5].res2:=integer(@vZOrder);
  result:= @PluginInfo;
end;




function cDownloadStatusCallback._AddRef: Integer;
begin
  Result := 0;
end;

function cDownloadStatusCallback._Release: Integer;
begin
  Result := 0;
end;

function cDownloadStatusCallback.QueryInterface(const IID: TGUID; out Obj): HResult;
begin
  if(GetInterface(IID,Obj)) then Result := 0
                            else Result := E_NOINTERFACE;
end;

function cDownloadStatusCallback.OnStartBinding(dwReserved: DWORD; pib: IBinding): HResult;
begin
  Result := S_OK;
end;

function cDownloadStatusCallback.GetPriority(out nPriority): HResult;
begin
  Result := S_OK;
end;

function cDownloadStatusCallback.OnLowResource(reserved: DWORD): HResult;
begin
  Result := S_OK;
end;

function cDownloadStatusCallback.OnStopBinding(hresult: HResult; szError: LPCWSTR): HResult; stdcall;
begin
  Result := S_OK;
end;

function cDownloadStatusCallback.GetBindInfo(out grfBINDF: DWORD; var bindinfo: TBindInfo): HResult; stdcall;
begin
  Result := S_OK;
end;

function cDownloadStatusCallback.OnDataAvailable(grfBSCF: DWORD; dwSize: DWORD; formatetc: PFormatEtc; stgmed: PStgMedium): HResult;
begin
  Result := S_OK;
end;

function cDownloadStatusCallback.OnObjectAvailable(const iid: TGUID; punk: IUnknown): HResult; stdcall;
begin
  Result := S_OK;
end;

function cDownloadStatusCallback.OnProgress(ulProgress, ulProgressMax, ulStatusCode: ULONG; szStatusText: LPCWSTR): HResult;
begin
  case ulStatusCode of
    BINDSTATUS_FINDINGRESOURCE,
    BINDSTATUS_CONNECTING,
    BINDSTATUS_BEGINDOWNLOADDATA,
    BINDSTATUS_DOWNLOADINGDATA:
    if (UserCancel) then
    begin
      Result := E_ABORT;
      SetEvent(HiEvent);
      exit;
    end;
  end;
  Result := S_OK;
end;




//////////////////////////////////////////////////////////////////
//   function ParseHtml                                         //
//                                                              //
//   Parses the html file and returns the scraped IP address    //
//////////////////////////////////////////////////////////////////
function ParseHtml(HtmlPage: string): string;
var
  IPText:string;
  CopyLoop  : integer;
  IPPos:integer;
begin
    case settingLookupMethod of
      0:
        IPText := HtmlPage;
      1:
      begin
        IPPos := Pos('Your IP  Is ', HtmlPage);
        for CopyLoop := IPPos + strlen('Your IP  Is ') to length(HtmlPage) do
        begin
          if not (HtmlPage[CopyLoop] in ['0'..'9', '.']) then break;
          IPText := IPText + HtmlPage[CopyLoop];
        end;
      end;
      2:
      begin
        IPPos := Pos('<b>', HtmlPage);
        for CopyLoop := IPPos + 13 to length(HtmlPage) do
        begin
          if not (HtmlPage[CopyLoop] in ['0'..'9', '.']) then break;
          IPText := IPText + HtmlPage[CopyLoop];
        end;
      end;
    end;
    Result := IPText;
end;

//////////////////////////////////////////////////////////////////
//   function IpAddress                                         //
//                                                              //
//   Downloads file and returns current IP Address              //
//   or default text if there was a failure                     //
//////////////////////////////////////////////////////////////////
function IpAddress : string;
var
  HtmlPage:string;
  IPText:string;
  IDHTTP:TIdHTTP;
begin
  LogMessage('IpAddress begin');
  IDHTTP := TIdHTTP.Create(nil);
  try try
    HtmlPage := IDHTTP.Get(BuildURL());
    LogMessage('ResponseCode: ' + IntToStr(IDHTTP.ResponseCode));
    LogMessage('ResponseText: ' + IDHTTP.ResponseText);
    IPText := ParseHtml(HtmlPage);
    LogMessage('IPText: ' + IPText);
  except
    on E : Exception do
      LogMessage('Error: ' + E.ClassName + ' raised error with the message '  + E.Message);
    // swallow errors, will return default text below
  end;
  finally
    IDHTTP.Free;
  end;

  LogMessage('IpAddress end');

  if length(IPText) > 0 then
    Result := IPText
  else
    Result := settingDefaultText;
end;



procedure CancelDownload();
var
  dwCode:DWORD;
begin
  if (hThread <> 0) then
  begin
    UserCancel:=true;
    WaitForSingleObject(HiEvent, 15000);
    dwCode := STILL_ACTIVE;
    GetExitCodeThread(hThread, dwCode);
    if (STILL_ACTIVE = dwCode) then
    begin
      SetThreadPriority(hThread, THREAD_PRIORITY_HIGHEST);
      if (WaitForSingleObject(hThread, 500) = WAIT_TIMEOUT)then
      begin
        SuspendThread(hThread);
        TerminateThread(hThread, 0);
      end;
    end;
    dwCode := STILL_ACTIVE;
    GetExitCodeThread(hThread, dwCode);
    CloseHandle(hThread);
    hThread := 0;
  end;
end;





function SwapColor(a:integer):integer;
asm
   BSWAP EAX
   SHR   EAX,8
end;


procedure ReadConfig;
// Reads the config settings
var
  CFG:TCFG;
  txt: PChar;
begin
  OpenCFGr(AData.PluginsCFG, @CFG);

  FindSection(szClassName, 0, @CFG);
  settingDebugMode := GetCFGBool('debug', False, @CFG);

  LogMessage('----------------');    // Can't write to log until debug mode is set
  LogMessage('ReadConfig begin');

  settingLookupMethod:= GetCFGInt(szLookupmethod, 0, @CFG);
  CheckInt(settingLookupMethod, 0, cLookupMethods, 0);

  settingZOrder:= GetCFGInt(szZOrder, 0, @CFG);
  CheckInt(settingZOrder, 0, cZOrder, 0);

  GetCFGString(szDefaultText, 'zIP', txt, MAX_PATH, @CFG);
  settingDefaultText := txt;
  tDisplayText := settingDefaultText;

  GetCFGString(szSkin, #0, settingSkin, MAX_PATH, @CFG);
  settingTextColor := SwapColor(GetCFGHex(szTextColor, $000000, @CFG));

  settingShadow := GetCFGBool(szShadow, FALSE, @CFG);
  settingShadowColor := SwapColor(GetCFGHex(szShadowColor, $FFFFFF, @CFG));

  settingRefreshTime := GetCFGInt(szRefreshTime, 30, @CFG);

  GetCFGFont(szFont, @settingFont, @CFG);
  GetFontHandle(@settingFont, GetStockObject(ANSI_VAR_FONT));

  settingLock := GetCFGBool(szLock, FALSE, @CFG);

  GetCFGPoint(szCoord, settingCoord, @CFG);

  GetCFGRect(szTextArea, settingTextArea, @CFG);
  if settingTextArea.Right <= settingTextArea.Left then
    settingTextArea.Right := 1000;
  if settingTextArea.Bottom <= settingTextArea.Top then
    settingTextArea.Bottom := 1000;

  CloseCFGr(@CFG);
  LogMessage('ReadConfig end');
end;



{---------------------------------------------------------------------}
{---------------------------------------------------------------------}



function BuildURL():string;
// Builds the URL depending on the lookup method

begin
  LogMessage('BuildURL begin');
  LogMessage('Lookup Method' + IntToStr(settingLookupMethod));

  case settingLookupMethod of
    0:
      result := 'http://www.whatismyip.org';
    1:
      result := 'http://www.whatismyip.com';
    2:
      result := 'http://www.ipchicken.com';
  end;
  LogMessage('BuildURL end');
end;

{---------------------------------------------------------------------}
function UpdateIP(pv:pointer):DWORD;
begin
  LogMessage('UpdateIP begin');
  sDecIP := IpAddress();
  tDisplayText := sDecIP;
  UpdateDisplay();
  ii.RedRaw();
  PostMessage(ii.wnd, CM_CLOSET, 0, 0);
  LogMessage('UpdateIP end');
  result:=0;
end;
{---------------------------------------------------------------------}
procedure CreateGetThread();
var
 dwID:DWORD;
begin
  // if thread still exists, then stop
  if hThread <> 0 then exit;
  hThread:=CreateThread(nil, 0, @UpdateIP, nil, 0, dwID);
end;

{---------------------------------------------------------------------}
procedure TimerCallBack(hWnd: HWND; Message: Word; TimerID: Word; SysTime: LongInt); stdcall;
begin
  LogMessage('timer');
  CreateGetThread();
end;




//////////////////////////////////////////////////////////////////
//   function GetMyPath                                         //
//                                                              //
//   Returns path of the plug-in                                //
//////////////////////////////////////////////////////////////////
function GetMyPath(): pchar;
var
  nstr1:array[0..255]of char;
begin
  try
    getmodulefilename(hInstance,nstr1,sizeof(nstr1));
    result := pchar(ExtractFilePath(nstr1));
  except
    on E : Exception do
    begin
      LogMessage('Error Getting Path: ' + E.Message);
      result := '';
    end;
  end;
end;


//////////////////////////////////////////////////////////////////
//   function LogMessage                                        //
//                                                              //
//   Writes a message to the log file                           //
//////////////////////////////////////////////////////////////////
procedure LogMessage(sMessage: string);
var
  logfile: pchar;
  F: TextFile;
begin
  if(settingDebugMode) then
  begin
    LogFile := pchar(GetMyPath + 'zIPLog.txt');
    Assignfile(F, LogFile);
    if FileExists(LogFile) then
      Append(F)
    else Rewrite(F);

    Writeln(F, DateToStr(Date) + ' ' + TimeToStr(Time) + ': ' + sMessage);
    Closefile(F);
  end;  
end;




exports
  InitGlobalModule,
  GetPluginInfo,
  DoneModule;
end.
